Subject: Re: [PATCH] arm64: mm: set ZONE_DMA size based on early IORT scan

From: Catalin Marinas <[email-masked]>
Date: Mon, 12 Oct 2020 12:24:53 +0100

On Mon, Oct 12, 2020 at 12:43:05PM +0200, Ard Biesheuvel wrote:
> On Mon, 12 Oct 2020 at 11:30, Ard Biesheuvel <[email-masked]> wrote:
> > On Mon, 12 Oct 2020 at 11:28, Catalin Marinas <[email-masked]> wrote:
> > > On Sat, Oct 10, 2020 at 11:31:53AM +0200, Ard Biesheuvel wrote:
> > > > diff --git a/arch/arm64/mm/init.c b/arch/arm64/mm/init.c
> > > > index f0599ae73b8d..829fa63c3d72 100644
> > > > --- a/arch/arm64/mm/init.c
> > > > +++ b/arch/arm64/mm/init.c
> > > > @@ -191,6 +191,14 @@ static void __init zone_sizes_init(unsigned long min, unsigned long max)
> > > >       unsigned long max_zone_pfns[MAX_NR_ZONES]  = {0};
> > > >
> > > >  #ifdef CONFIG_ZONE_DMA
> > > > +     if (IS_ENABLED(CONFIG_ACPI)) {
> > > > +             extern unsigned int acpi_iort_get_zone_dma_size(void);
> > >
> > > Nitpick: can we add this prototype to include/linux/acpi_iort.h?
> > >
> > > > +
> > > > +             zone_dma_bits = min(zone_dma_bits,
> > > > +                                 acpi_iort_get_zone_dma_size());
> > > > +             arm64_dma_phys_limit = max_zone_phys(zone_dma_bits);
> > > > +     }
> > > > +
> > > >       max_zone_pfns[ZONE_DMA] = PFN_DOWN(arm64_dma_phys_limit);
> > >
> > > I think we should initialise zone_dma_bits slightly earlier via
> > > arm64_memblock_init(). We'll eventually have reserve_crashkernel()
> > > called before this and it will make use of arm64_dma_phys_limit for
> > > "low" reservations:
> > >
> > > https://lore.kernel.org/linux-arm-kernel/[email-masked]/
> > >
> >
> > We don't have access to the ACPI tables yet at that point.
> 
> Also, could someone give an executive summary of why it matters where
> the crashkernel is loaded? As far as I can tell, reserve_crashkernel()
> only allocates memory for the kernel's executable image itself, which
> can usually be loaded anywhere in memory. I could see how a
> crashkernel might need some DMA'able memory if it needs to use the
> hardware, but I don't think that is what is going on here.

I thought the crashkernel needs some additional reserved RAM as well to
be able to run. It should not touch the original kernel's memory as it
usually needs to dump it.

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel